import { Plugin } from 'prosemirror-state';
import type { Node } from 'prosemirror-model';
import { NodeView } from 'prosemirror-view';
import 'katex/dist/katex.min.css';
export declare abstract class MathNodeView implements NodeView {
    dom: HTMLElement;
    contentDOM: HTMLElement;
    protected node: Node;
    protected texContent: string;
    protected mathViewDOM: HTMLElement;
    abstract createDOM(): Record<'dom' | 'contentDOM' | 'mathViewDOM', HTMLElement>;
    abstract isDisplayMode(): boolean;
    constructor(node: Node);
    update(node: Node): boolean;
    protected renderKatex(): void;
    protected getTexContent(): string;
}
export declare class MathInlineNodeView extends MathNodeView {
    isDisplayMode(): boolean;
    createDOM(): Record<'dom' | 'contentDOM' | 'mathViewDOM', HTMLElement>;
    protected createMathInlineDOM(): {
        container: HTMLSpanElement;
        content: HTMLSpanElement;
    };
}
export declare class MathBlockNodeView extends MathNodeView {
    isDisplayMode(): boolean;
    createDOM(): Record<'dom' | 'contentDOM' | 'mathViewDOM', HTMLElement>;
}
export declare const mathViewAndEditPlugin: () => Plugin<any>;
