"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmTabs = exports.tabPanelType = exports.tabsListType = exports.tabsType = exports.tabType = exports.TabsNode = void 0;
const plugins_1 = require("./plugins");
const prosemirror_commands_1 = require("prosemirror-commands");
const YfmTabsSpecs_1 = require("./YfmTabsSpecs");
const ignoreMutation = (node, view, getPos) => (mutation) => {
    if (mutation instanceof MutationRecord &&
        mutation.type === 'attributes' &&
        mutation.attributeName) {
        const newAttr = mutation.target.getAttribute(mutation.attributeName);
        view.dispatch(view.state.tr.setNodeMarkup(getPos(), null, Object.assign(Object.assign({}, node.attrs), { [mutation.attributeName]: String(newAttr) })));
        return true;
    }
    return false;
};
var YfmTabsSpecs_2 = require("./YfmTabsSpecs");
Object.defineProperty(exports, "TabsNode", { enumerable: true, get: function () { return YfmTabsSpecs_2.TabsNode; } });
Object.defineProperty(exports, "tabType", { enumerable: true, get: function () { return YfmTabsSpecs_2.tabType; } });
Object.defineProperty(exports, "tabsType", { enumerable: true, get: function () { return YfmTabsSpecs_2.tabsType; } });
Object.defineProperty(exports, "tabsListType", { enumerable: true, get: function () { return YfmTabsSpecs_2.tabsListType; } });
Object.defineProperty(exports, "tabPanelType", { enumerable: true, get: function () { return YfmTabsSpecs_2.tabPanelType; } });
const YfmTabs = (builder) => {
    builder.use(YfmTabsSpecs_1.YfmTabsSpecs, {
        // @ts-expect-error
        tabView: 
        // FIX: ignore mutation and don't rerender node when yfm.js switch tab
        () => (node, view, getPos) => ({
            ignoreMutation: ignoreMutation(node, view, getPos),
        }),
        // @ts-expect-error
        tabPanelView: 
        // FIX: ignore mutation and don't rerender node when yfm.js switch tab
        () => (node, view, getPos) => ({
            ignoreMutation: ignoreMutation(node, view, getPos),
        }),
    });
    builder.addKeymap(() => ({
        Backspace: (0, prosemirror_commands_1.chainCommands)(plugins_1.tabPanelBackspace, plugins_1.tabBackspace),
    }));
};
exports.YfmTabs = YfmTabs;
